<?php namespace Seller\Api;
use Dever;
class Order
{
    private $info;
    public function test()
    {
        $token = $this->token();
        $request = Dever::input();
        return \Dever\Secure::get($request, $token);
    }

    # 队列提交订单 不做任何数据库操作
    public function submit_secure(){}
    public function submit_token(){return $this->token();}
    public function submit()
    {
        # 余额保存在redis中
        # 商户信息和折扣也保存在redis中
        # 扣款
        # 收单
    }

    # 直接提交订单
    public function act_commit(){}
    //public function act_secure(){}
    //public function act_token(){return $this->token();}
    public function act()
    {
        if (!$this->info) {
            $this->token();
        }
        $code = Dever::input('code');
        if (!$code) {
            Dever::error('请传入商品编码');
        }
        $account = Dever::input('account');
        if (!$account) {
            Dever::error('请传入账号');
        }
        $order = Dever::input('order');
        if (!$order) {
            Dever::error('请传入订单号');
        }

        $sku = Dever::db('info_sku', 'goods')->find(array('code' => $code));
        if (!$sku) {
            Dever::error('商品编码不存在');
        }
        $goods = Dever::db('info', 'goods')->find($sku['info_id']);
        if (!$goods) {
            Dever::error('商品不存在');
        }
        if ($goods['status'] == 2) {
            Dever::error('商品已下架');
        }
        $cate = Dever::db('cate', 'goods')->find($goods['cate_id']);
        if ($cate && $cate['rule'] && !preg_match($cate['rule'], $account)) {
            Dever::error($account . '不符合规则');
        }

        # 查询折扣
        $seller_goods = Dever::db('goods', 'seller')->find(array('seller_id' => $this->info['id'], 'goods_id' => $sku['info_id'], 'sku_id' => $sku['id']));
        if ($seller_goods && $seller_goods['discount'] > 0) {
            $this->info['discount'] = $seller_goods['discount'];
        }
        $cash = round($sku['value'] * $this->info['discount'], 2);

        # 查询余额是否充足，看看这里是否需要用redis
        /* start */
        $this->info['yue'] = $this->info['credit'] + $this->info['cash'];
        if ($this->info['yue'] < $cash) {
            Dever::error('余额不足');
        }
        $state = Dever::db('info', 'seller')->update(array('id' => $this->info['id']), array('cash' => array('-', $cash)));
        /* end */

        # 验证订单号
        $check = Dever::db('order', 'seller')->find(array('seller_id' => $this->info['id'], 'seller_order_num' => $order));
        if ($check) {
            Dever::error('订单重复');
        }

        # 开始下单
        $data['account'] = $account;
        $data['goods_id'] = $sku['info_id'];
        $data['sku_id'] = $sku['id'];
        $data['num'] = 1;
        $data['cash'] = $sku['value'];
        $data['price'] = $cash;
        $data['seller_id'] = $this->info['id'];
        $data['seller_order_num'] = $order;
        $data['seller_request'] = Dever::json_encode(Dever::input());
        $order_num = Dever::load('order', 'seller')->add($data);

        return array
        (
            'order_status' => 1,
            'order_num' => $order_num,
        );
    }

    # 查询订单

    # 查询账户

    private function token()
    {
        $appkey = Dever::input('appkey');
        if (!$appkey) {
            Dever::error('appkey错误');
        }
        $this->info = Dever::db('info', 'seller')->find(array('appkey' => $appkey));
        if (!$this->info) {
            Dever::error('商户不存在');
        }
        if ($this->info && $this->info['status'] == 2) {
            Dever::error('商户已封禁');
        }
        return $this->info['appsecret'];
    }

    # 处理订单
    public function handle()
    {
        Dever::load('order', 'seller')->handle();
        return 'ok';
    }
}