<?php namespace Seller\Lib;
use Dever;
use Dever\Helper\Str;
class Order
{
    # 新增订单
    public function add($data)
    {
        $data['order_num'] = $this->createOrder();
        $id = Dever::db('order', 'seller')->insert($data);
        if (!$id) {
            Dever::error('下单失败');
        }
        return $data['order_num'];
    }

    # 处理已下单的订单
    public function handle_commit(){}
    public function handle()
    {
        $data = Dever::db('order', 'seller')->select(array('status' => 1), array('limit' => 100))->fetchAll();
        foreach ($data as $k => $v) {
            //Dever::db('order', 'seller')->update($v['id'], array('status' => 2));
            $status = $this->handleItem($v);
            if ($status) {
                //Dever::db('order', 'seller')->update($v['id'], array('status' => $status));
            }
        }
    }

    private function handleItem($info, $selected = array())
    {
        # 查找渠道
        $channel_list = Dever::db('channel', 'seller')->select(array('seller_id' => $info['seller_id'], 'goods_id' => $info['goods_id']))->fetchAll();
        if (!$channel_list) {
            return $this->notify($info, '通道未开启');
        }
        $channel = array();
        foreach ($channel_list as $k => $v) {
            if ($selected && isset($selected[$v['channel_id']])) {
                continue;
            }
            if (!$v['sku_id']) {
                $channel_sku = Dever::db('goods', 'channel')->find(array('channel_id' => $v['channel_id'], 'goods_id' => $info['goods_id'], 'sku_id' => $info['sku_id']));
                if ($channel_sku) {
                    $channel = $v['channel_id'];
                    break;
                }
            } else {
                $sku_id = explode(',', $v['sku_id']);
                if (in_array($info['sku_id'], $sku_id)) {
                    $channel = $v['channel_id'];
                    break;
                }
            }
        }
        if (!$channel) {
            return $this->notify($info, '通道未开启');
        }

        $channel = Dever::db('info', 'channel')->find($channel);
        if (!$channel) {
            return $this->notify($info, '通道未开启');
        }
        if ($channel['status'] == 2) {
            return $this->notify($info, '通道未开启');
        }

        print_r($channel);die;

        //向渠道发起请求 下单
        Dever::load('func/api', 'connect')->add(1, $channel);

        return false;
    }

    # 商户发起回调
    public function notify($info, $msg, $other = array())
    {
        $status = 11;
        if ($msg == 'ok') {
            $status = 10;
        }

        # 获取商户回调地址，向商户发起回调
        $seller_request = Dever::json_decode($info['seller_request']);
        if (isset($seller_request['notify']) && $seller_request['notify']) {
            $notify = $seller_request['notify'];
            $param = array();
            $param['seller_order_num'] = $info['seller_order_num'];
            $param['order_num'] = $info['order_num'];
            $param['order_status'] = $status;
            $param['order_cash'] = $info['cash'];
        }

        if ($status == 11) {
            # 失败，余额加回来
            Dever::db('info', 'seller')->update(array('id' => $info['id']), array('cash' => array('+', $info['price'])));
        }
        return $status;
    }

    public function createOrder()
    {
        $where['order_num'] = Str::order('C');
        $state = Dever::db('order', 'seller')->find($where);
        if (!$state) {
            return $where['order_num'];
        } else {
            return $this->createOrder();
        }
    }
}